/************************************
 * list.c
 * ------
 * A full featured
 * doubly linked list, with 
 * template functionality implemented
 * through the use of macros.
 * ------
 * Copyright 
 * Brandon Lucia, 2005.
 * http://uniquity.net
 * **********************************/
#include "list.h"
#include <stdlib.h>
#include <stdio.h>

list *newList(int DataSize){
	list *l;
	if(l = (list *) malloc(sizeof(list))){
		l->head = NULL;
		l->tail = NULL;
		l->size=0;
		l->dsize=DataSize;
		return l;
	}else{
		return NULL;
	}
}

int size(list *l){
	return l->size;
}

element *getElem(list *l,int num){
	int i;
	if(num>l->size || num<0)
		return NULL;
	if(l->head){
		element *it = l->head;
		for(i=0; i<num; i++){
			if(!it->next)
				break;
			else
				it=it->next;
		}
		return it;
	}else{
		return NULL;
	}
}
			
void *getVal(list *l,int num){
	return (getElem(l,num))->data;
}

void *g(list *l,int num){
	return getVal(l,num);
}


void *add_front(list *l){
	element * newelem;
	newelem = (element *) malloc(sizeof(element));
	if(newelem){
		if(l->head){
			//2 or more elements
			l->head->prev = newelem;
			newelem->next = l->head;
			newelem->prev = NULL;
			newelem->data = malloc(l->dsize);
			l->head = newelem;
			l->size++;
			return l->head->data;
		}else{
			//no list
			l->head = newelem;
			l->head->next = NULL;
			l->head->prev= NULL;
			l->tail = l->head;
			l->size++;
			newelem->data = malloc(l->dsize);
			return l->head->data;
		}
	}else{
		//no new elem 
		return 0;
	}
	
}

void *add_back(list *l){
	element * newelem;
	newelem = (element *) malloc(sizeof(element));
	if(newelem){
		if(l->tail){
			//2 or more elements
			newelem->prev = l->tail;
			l->tail->next= newelem;
			newelem->next = NULL;
			newelem->data = malloc(l->dsize);
			l->tail = newelem;
			l->size++;
			return l->tail->data;
		}else{
			//no list
			l->tail = newelem;
			l->tail->next = NULL;
			l->tail->prev= NULL;
			l->head= l->tail;
			l->size++;
			newelem->data = malloc(l->dsize);
			return l->tail->data;
		}
	}else{
		//no new elem 
		return 0;
	}
	
}




void *a(list *l){
	return add_front(l);
}

element *rem_front(list *l){
	if(l->head){
		if(l->head->next){
			//2 or more elements
			element *e;
			e = l->head->next;
			e->prev = NULL;
			free(l->head);
			l->head = e;
			l->size--;
			return l->head;
		}else{
			//list is only a head
			free(l->head);
			l->head = l->tail = NULL;
			l->size--;
			return 0;	
		}
	}else{
		//no list
		return 0;
	}
}

void rem_back(list *l){
	if(l->tail){
		if(l->tail->prev){
			//2 or more elements
			element *e;
			e = l->tail->prev;
			e->next = NULL;
			free(l->tail);
			l->tail = e;
			l->size--;
			return;
		}else{
			//list is only a tail(and also a head
			free(l->tail);
			l->head = l->tail = NULL;
			l->size=0;
			return;
		}
	}else{
		return;
	}
}

void rem_n(list *l,int n){
	if(!l->head)
		return;
	if(n>l->size || n<0 || !size(l))
		return;
	element * e = getElem(l,n);
	if(!e)
		return;
	if(e!=l->head && e!=l->tail){
		if(e->prev)
			e->prev->next = e->next;
		if(e->next)
			e->next->prev = e->prev;
		l->size--;
		free(e);
	}else if(e==l->head){
		if(l->head->next){
			//2 or more elements
			element *e;
			e = l->head->next;
			e->prev = NULL;
			free(l->head);
			l->head = e;
			l->size--;
			return;
		}else{
			//list is only a head
			free(l->head);
			l->head = NULL;
			l->head = NULL;
			l->size--;
			return;	
		}
	}else if(e==l->tail){
		if(l->tail->prev){
			//2 or more elements
			element *e;
			e = l->tail->prev;
			e->next = NULL;
			free(l->tail);
			l->tail = e;
			l->size--;
			return;
		}else{
			//list is only a tail(and also a head
			free(l->tail);
			l->head = l->tail = NULL;
			l->size=0;
			return;
		}
	}
	else{
		return;
	}
}

