#ifndef LIST_H
#define LIST_H
/******************************************************************************
 *CREATELIST(type): type is the type of the list to be created
 *		ie:  list *l = CREATELIST(int);
 *GET(type,list,num): type is the type of the items in the list
 * 		      list is a list that has already been created
 * 		      num is the index of the list element to remove
 *PUSH_FRONT/PUSH_BACK(type,list,value):
 *		      type is the type of the items in the list
 *		      list is the list of type type
 *		      value is a thing of type type to add at the front of back
 *POP_FRONT/POP_BACK(type,list,out):
 *		      type is the type of the items in the list
 *		      list is the list of type type
 *		      out is the thing into which the value of the popped item
 *		      will be placed.
 *POP_N(type,list,n,out): type is the type of the items in the list
 *			  list is a list of type type
 *			  n is the index of the item to pop
 *			  out is the thing into which the value of the popped
 *			  item will be placed.
 *ie:
 *		list *aList;
 *		aList = CREATELIST(int);
 *		PUSH_FRONT(int,aList,10);
 *		PUSH_BACK(int,aList,10);
 *		GET(int,aList,0);
 *		GET(int,aList,1);
 *		int ret;
 *		int ret2;
 *		POP_N(type,aList,1,ret);
 *		POP_BACK(type,aList,ret2);
 *		POP_FRONT(type,aList,ret2); //list is empty, ret2 is null
 ******************************************************************************/

#define CREATELIST(type) newList(sizeof(type))
#define GET(type,list,num) *((type*)getVal(list,num))
#define PUSH_FRONT(type,list,value) *((type*) add_front(list))=value
#define PUSH_BACK(type,list,value) *((type*) add_back(list))=value
#define POP_FRONT(type,list,out) out=GET(type,list,0);rem_front(list)
#define POP_BACK(type,list,out) out=GET(type,list,size(list));rem_back(list)
#define POP_N(type,list,n,out) out=GET(type,list,n);rem_n(list,n)

typedef struct elem {
	struct elem * next;
	struct elem * prev;
	void * data;
} element;

typedef struct {
	element * head;
	element * tail;
	int size;
	int dsize;
} list;
element *add(list *l,element *e);
#endif
